public class CubbyHole3 { 
    private int content; 
    private boolean empty = true; 
    public synchronized void put(int value) { 
        while (!empty) { 
            try {
                wait(); //släpp låset och vänta på att väckas
            } 
            catch (InterruptedException e) {} 
        } 
        content = value; 
        empty = false; 
        notifyAll(); //väck alla som väntar 
    }//put
    public synchronized int get() { 
        while(empty) { 
            try {
                wait(); //släpp låset och vänta på att väckas
            } 
            catch (InterruptedException e) {} 
        } 
        empty = true; 
        notifyAll(); //väck alla som väntar på låset
        return content; 
    }//get
}//CubbyHole3
