import java.util.ArrayList; 
public class JobShop { 
    //private Queue theQueue = new Queue(); 
    private Queue<String> theQueue = new Queue<String>(); 
    private ArrayList<Thread> threads = new ArrayList<Thread>(); 
    public JobShop() throws InterruptedException { 
        createAndStartThreads(); 
        Thread.sleep(20000); 
        stopThreads(); 
        System.out.println("Jobs left in queue: " + theQueue.size()); 
        System.exit(0); 
    }//constructor 
    public void stopThreads() { 
        for (Thread t : threads) 
            t.interrupt(); 
    }//stopThread
    public void createAndStartThreads() { 
        threads.add( new Producer("Lamm",6237, theQueue)); 
        threads.add(new Producer("Alto",2846, theQueue)); 
        threads.add(new Producer("Holm",1239, theQueue)); 
        threads.add(new Consumer("Erik",982, theQueue)); 
        for (Thread t : threads) 
            t.start(); 
    }//cerateAndStartThreads
    public static void main(String[] arg) throws InterruptedException { 
        JobShop j = new JobShop(); 
    }//main
}//JobShop
