public class Main { 
    private BackgroundJob backgroundJob = new BackgroundJob(1000,10); 
    public Main() { 
        backgroundJob.start();  // Start background thread 
        foregroundJob();           // Do foreground job in parallel 
    } //constructor
    public void foregroundJob() { 
        int i = 0; 
        while (i <= 20 && ! Thread.interrupted() ) { 
            try { Thread.sleep(200); } 
            catch (InterruptedException e) { break; } 
            System.out.println("Foreground: " + i++); 
        } 
        try { backgroundJob.join(); } 
        catch (InterruptedException e) { } 
        System.out.println("Background result: " +
        backgroundJob.getResult() ); 
        System.out.println("Foreground work continues..."); 
    }//foregroundJob 
    public static void main(String[] arg) { 
        Main m = new Main(); 
    }//main 
} //Main 
