import java.util.ArrayList; 
//public class  Queue { 
public class Queue<T> { 
    //private ArrayList<String> queue = new ArrayList<String>(); 
    private ArrayList<T> queue = new ArrayList<T>(); 
    public int size() { 
        return queue.size(); 
    }//size 
    //public synchronized void put(String obj) { 
    public synchronized void put(T obj) { 
        queue.add(obj); 
        notifyAll(); 
    }//put
    //public synchronized String take() { 
    public synchronized T take() { 
        while (queue.isEmpty()) { 
            try { 
                wait(); 
            } 
            catch (InterruptedException e) { 
                return null; 
            } 
        } 
        //String obj = queue.get(0); 
        T obj = queue.get(0); 
        queue.remove(0); 
        return obj; 
    }//take
}//Queue
